Initial GIT commit: pt 0.0.9 (2007-11-15)
authorAlexander Barton <alex@barton.de>
Fri, 27 Jun 2008 10:56:48 +0000 (12:56 +0200)
committerAlexander Barton <alex@barton.de>
Fri, 27 Jun 2008 10:56:48 +0000 (12:56 +0200)
AUTHORS [new file with mode: 0644]
COPYING [new file with mode: 0644]
ChangeLog [new file with mode: 0644]
INSTALL [new file with mode: 0644]
Makefile [new file with mode: 0644]
README [new file with mode: 0644]
bin/pt [new file with mode: 0755]
etc/pt.conf [new file with mode: 0644]

diff --git a/AUTHORS b/AUTHORS
new file mode 100644 (file)
index 0000000..43c38bd
--- /dev/null
+++ b/AUTHORS
@@ -0,0 +1,12 @@
+
+                         pt -- the MacPorts port tool
+              Copyright (c)2007 Alexander Barton, alex@barton.de
+
+                                   Authors
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Alexander Barton, <alex@barton.de> (alex)
+
+
+-- 
+$Id$
\ No newline at end of file
diff --git a/COPYING b/COPYING
new file mode 100644 (file)
index 0000000..14db8fc
--- /dev/null
+++ b/COPYING
@@ -0,0 +1,340 @@
+                   GNU GENERAL PUBLIC LICENSE
+                      Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.
+ 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                           Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Library General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+\f
+                   GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+\f
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+\f
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+\f
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+                           NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+                    END OF TERMS AND CONDITIONS
+\f
+           How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Library General
+Public License instead of this License.
diff --git a/ChangeLog b/ChangeLog
new file mode 100644 (file)
index 0000000..3243c2f
--- /dev/null
+++ b/ChangeLog
@@ -0,0 +1,36 @@
+
+                         pt -- the MacPorts port tool
+              Copyright (c)2007 Alexander Barton, alex@barton.de
+
+                              History & Changes
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+pt 0.0.9 (2007-11-15)
+
+  - Implemented "make install".
+  - New target "info": show information to specified port.
+
+pt 0.0.8 (2007-09-10)
+
+  - fixed the function which checks if a port is installed or not:
+    Port_Installed always returned false.
+  - New target "outdated" (aka "list-outdated"): show outdated ports.
+  - Fixed the return code of some functions, for example "update".
+
+pt 0.0.7 (2007-05-09)
+
+  - Added "check" and "distcheck" make targets.
+  - Display number of inactive ports as well, if any.
+  - Check for "Maintainers:" field instead for "Platforms:", when using
+    "port info" to check for a port.
+  - Display number of required ports when listing dependencies.
+  - Respect the terminal width when dumping "package state lists" like
+    which packages are required for an installation.
+
+pt 0.0.6 (2007-04-16)
+
+  - First "public" release, announced in #alt on irc.barton.de :-)
+
+
+-- 
+$Id$
diff --git a/INSTALL b/INSTALL
new file mode 100644 (file)
index 0000000..65726ca
--- /dev/null
+++ b/INSTALL
@@ -0,0 +1,36 @@
+
+                         pt -- the MacPorts port tool
+              Copyright (c)2007 Alexander Barton, alex@barton.de
+
+                              Installation Notes
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+I) Automatic Installation
+
+Type "make install". This will place the pt script in /usr/local/bin/pt and
+the configuration file to /etc/.
+
+That's it.
+
+
+II) Manual Installation
+
+Copy the file "bin/pt" to some location, for example /usr/local/bin and make
+it executable by the system:
+
+- mkdir -p /usr/local/bin
+- cp bin/pt /usr/local/bin/
+- chmod 755 /usr/local/bin/pt
+
+Optionally, you can copy the sample configuration file to /etc:
+
+- cp etc/pt.conf /etc/
+- chmod 644 /etc/pt.conf
+
+Now try something like "pt --help".
+
+That's it. Have fun!
+
+
+-- 
+$Id$
diff --git a/Makefile b/Makefile
new file mode 100644 (file)
index 0000000..de40815
--- /dev/null
+++ b/Makefile
@@ -0,0 +1,45 @@
+# pt -- the MacPorts port tool"
+# Copyright (c)2007 Alexander Barton, alex@barton.de
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+# Please read the file COPYING, README and AUTHORS for more information.
+#
+# $Id$
+#
+
+all: pt
+
+pt:
+       chmod 755 bin/pt
+
+distclean: clean
+       find . -name '.DS_Store' -exec rm -f {} ";"
+
+clean:
+
+check: all
+       @echo -n "Checking \"pt\" script ... "
+       @bin/pt --version >/dev/null 2>&1; if [ $$? -eq 0 ]; then \
+        echo "OK."; else echo "Failed!"; exit 1; fi
+
+install: all
+       install -d -o root -g wheel -m 755 /usr/local/bin
+       install -v -o root -g wheel -m 755 bin/pt /usr/local/bin
+       [ -e /etc/pt.conf ] || install -v -o root -g wheel -m 644 etc/pt.conf /etc
+
+dist: distclean
+       name=`basename $$PWD`; \
+        version=`grep "VERSION=" bin/pt | cut -d'"' -f2`; \
+         ditto --norsrc . "/tmp/$$$$/$$name-$$version"; \
+         tar cvzf "$$name-$$version.tar.gz" -C "/tmp/$$$$" \
+          --exclude '*.tar*' "$$name-$$version"; \
+         rm -r "/tmp/$$$$"
+
+distcheck: distclean check dist
+
+.PHONY: all install
+
+# -eof-
diff --git a/README b/README
new file mode 100644 (file)
index 0000000..f012e4d
--- /dev/null
+++ b/README
@@ -0,0 +1,13 @@
+
+                         pt -- the MacPorts port tool
+              Copyright (c)2007 Alexander Barton, alex@barton.de
+
+                                   "README"
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+There is no real documentation at the moment, sorry!
+Please have a look at the INSTALL document to get some more information.
+
+
+-- 
+$Id$
\ No newline at end of file
diff --git a/bin/pt b/bin/pt
new file mode 100755 (executable)
index 0000000..5ab4cb0
--- /dev/null
+++ b/bin/pt
@@ -0,0 +1,949 @@
+#!/bin/bash
+#
+# pt -- the MacPorts port tool"
+# Copyright (c)2007 Alexander Barton, alex@barton.de
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+# Please read the file COPYING, README and AUTHORS for more information.
+#
+# $Id$
+#
+
+NAME=`basename "$0"`
+VERSION="0.0.9"
+DATE="2007-11-15"
+
+QUIET=
+PORT_VERBOSE=
+VERBOSE=
+DEBUG=
+
+UPGRADE_REMOVE_INACTIVE=1
+CLEAN_WORKDIR=1
+
+declare -i WIDTH=${COLUMNS:-80}
+
+LINE="-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------"
+
+Version() {
+       # Display version information.
+
+       echo "$NAME $VERSION ($DATE) -- the MacPorts port tool"
+       echo "Copyright (c)2007 Alexander Barton, alex@barton.de"
+       echo
+       echo "This is free software; see the source for copying conditions. There is NO"
+       echo "warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE."
+       echo
+}
+
+Usage() {
+       # Display some usage information and exit.
+
+       Version
+       echo "Usage: $0 <options> <command> [<args> ...]"
+       echo
+       echo "Available commands:"
+       echo "  deps <port> [<port> [...]]     -- examine dependencies"
+       echo "  install <port> [<port> [...]]  -- install port(s)"
+       echo "  remove <port> [<port> [...]]   -- remove port(s)"
+       echo "  clean <port> [<port> [...]]    -- clean port build files"
+       echo "  update                         -- update port database"
+       echo "  upgrade                        -- upgrade outdated port(s)"
+       echo "  search <term>                  -- search for port(s)"
+       echo "  list <term>                    -- list port(s)"
+       echo "  info <port>                    -- display details of a port"
+       echo "  status                         -- show MacPorts status"
+       echo
+       echo "The following global options are available:"
+       echo "  -q: quiet mode, little output      +q: no quiet mode, normal output"
+       echo "  -v: enable verbose mode            +v: disable verbose mode"
+       echo "  -V: verbose port(1) messages       +V: no verbose port(1) messages"
+       echo "  -d: enable debug mode              +d: disable verbose mode"
+       echo
+       Clean_Exit 1
+}
+
+Init() {
+       # Initialize "state machine", clear temporary files.
+
+       Verbose_Msg "Initializing port states ..."
+       port list >"$TMPDIR/available"
+       Debug_Msg "Listing installed ports ..."
+       port installed | grep "^  " >"$TMPDIR/installed"
+       Debug_Msg "Listing inactive ports ..."
+       port list inactive >"$TMPDIR/inactive"
+       echo -n '' >"$TMPDIR/required.all"
+       echo -n '' >"$TMPDIR/missing.all"
+       echo -n "" >"$TMPDIR/outdated"
+       echo -n "" >"$TMPDIR/outdated.info"
+
+       declare -i c_avail=`cat "$TMPDIR/available" | wc -l`
+       declare -i c_inst=`cat "$TMPDIR/installed" | wc -l`
+       declare -i c_inact=`cat "$TMPDIR/inactive" | wc -l`
+
+       [ $c_inst -eq $c_avail ] && c_inst=0
+       [ $c_inact -eq $c_avail ] && c_inact=0
+       [ $c_inact -eq 0 ] && s="" || s=" ($c_inact inactive)"
+       Verbose_Msg "$c_avail ports available, $c_inst installed$s."
+}
+
+Reset() {
+       # Reset "required" and "missing" package lists, move saved
+       # packages to "required.all"/"missing.all" lists for later
+       # processing.
+
+       Debug_Msg "Resetting internal state ..."
+       rm -f "$TMPDIR/tmp"*
+       
+       [ -r "$TMPDIR/required" ] \
+               && cat "$TMPDIR/required" >>"$TMPDIR/required.all"
+       echo -n '' >"$TMPDIR/required"
+       
+       [ -r "$TMPDIR/missing" ] \
+               && cat "$TMPDIR/missing" >>"$TMPDIR/missing.all"
+       echo -n '' >"$TMPDIR/missing"
+}
+
+Check_Root_Perm() {
+       # Check, if this script is running with root privileges.
+
+       [ "$UID" -eq 0 -o "$EUID" -eq 0 ] && return 0
+       Error_Msg "This function must be executed with root privileges!"
+       Clean_Exit 1
+}
+
+Debug_Tmpdir() {
+       # List contents of temporary directory to console.
+       echo "--- $TMPDIR ---"; ls -al "$TMPDIR"; echo "---"
+}
+
+Debug_Dump_File() {
+       # Dump contents of a file to console.
+       echo "--- $1 ---"; cat "$1"; echo "---"
+}
+
+Clean_Exit() {
+       # Exit this scripts after cleaning up.
+       # $1: exit code
+
+       Debug_Msg "Cleaning up ..."
+       [ -n "$TMPDIR" ] && rm -rf "$TMPDIR"
+       Debug_Msg "Done. Exit code: $1"
+       exit $1
+}
+
+Clean_Exit_Signal() {
+       # Exit this script with exit code 127, used when an interup signal
+       # (SIGINT) has been catched.
+
+       echo
+       Clean_Exit 127
+}
+
+Msg() {
+       # Display message, if not running in "quiet" mode.
+       # $*: message to display.
+
+       [ -n "$QUIET" ] && return
+       if [ "$1" = "-n" ]; then
+               shift
+               echo -n "$*"
+       else
+               echo "$*"
+       fi
+}
+
+Msg_NoQuiet() {
+       # Display message, even when running in "quiet" mode.
+       # $*: message to display.
+
+       if [ "$1" = "-n" ]; then
+               shift
+               echo -n "$*"
+       else
+               echo "$*"
+       fi
+}
+
+Verbose_Msg() {
+       # Display message when running in "debug" or "verbose" mode.
+       # $*: message to display.
+
+       [ -z "$QUIET" -a -n "$VERBOSE" ] && echo $*
+}
+
+Debug_Msg() {
+       # Display message when running in "debug" mode.
+       # $*: message to display.
+
+       [ -n "$DEBUG" ] && echo $*
+}
+
+Warn_Msg() {
+       # Display warning message.
+       # $*: message to display.
+
+       echo "Warning: $*"
+}
+
+Error_Msg() {
+       # Display error message.
+       # $*: message to display.
+
+       echo "Error: $*"
+}
+
+Prompt() {
+       tty >/dev/null 2>&1
+       [ $? -ne 0 ] && return 0
+       
+       x="_"
+       Msg_NoQuiet -n "$* [Y/n] "
+       while [ "$x" != "" -a "$x" != "n" -a "$x" != "N" -a "$x" != "y" -a "$x" != "Y" ]; do
+               read -s -n 1 x
+       done
+       [ -z "$x" ] && x="yes"
+       [ "$x" = "n" ] && x="no"
+       [ "$x" = "y" ] && x="yes"
+       Msg_NoQuiet "- $x"
+       [ "$x" = "no" ] && return 1 || return 0
+}
+
+PortCmd()  {
+       # Call the real "port(1)" command, show and hide output as configured.
+       # $*: arguments for port(1).
+
+       local args="-q "
+       [ -n "$VERBOSE" ] && args=""
+       [ -n "$PORT_VERBOSE" ] && args="-v "
+       [ -n "$DEBUG" ] && args="-v -d "
+       local cmd="port $args$*"
+
+       declare -i a=${#cmd}+4; a=$WIDTH-$a; a=$a/2
+       local bottom="$LINE"
+       local top="${LINE:0:$a}[ $cmd ]${LINE}"
+
+       local r=1
+       if [ "$args" = "" ]; then
+               $cmd | while read x; do
+                       msg=$(echo "$x"|sed -e 's/--->//g'|sed -e 's/^  //g')
+                       msg=" - $msg"
+                       if [ ${#msg} -ge $WIDTH ]; then
+                               declare -i w=$WIDTH-3
+                               echo "${msg:0:$w}..."
+                       else
+                               echo "$msg"
+                       fi
+               done; r=$?
+       elif [ "$args" = "-v " -o "$args" = "-v -d " ]; then
+               Msg_NoQuiet "${top:0:$WIDTH}"
+               $cmd; r=$?
+               Msg_NoQuiet "${bottom:0:$WIDTH}"
+       else
+               $cmd >/dev/null 2>&1 ; r=$?
+       fi
+
+       return $r
+}
+
+Port_Exists() {
+       # Check, if the given port exists
+       # $1: port
+
+       port info "$1" 2>/dev/null | grep 'Maintainers: ' >/dev/null; local r=$?
+       if [ $r -ne 0 ]; then
+               Error_Msg "Port \"$1\" does not exist!"
+               return $r
+       fi
+       Debug_Msg "Port \"$1\" exists. Ok."
+       return 0
+}
+
+Port_Installed() {
+       # Check, if the given port is installed
+       # $1: port
+
+       Port_Exists "$1"
+       [ $? -eq 0 ] || return 1
+
+       grep "^  $1 " "$TMPDIR/installed" >/dev/null 2>&1; local r=$?
+       if [ $r -ne 0 ]; then
+               Error_Msg "Port \"$1\" is not installed!"
+               return $r
+       fi
+       Debug_Msg "Port \"$1\" is installed. Ok."
+       return 0
+}
+
+Dump_Package_File() {
+       # Display contents of a "pt package-list file", like "required[.all]".
+       # $1: title text
+       # $2: package-list file name
+       # $3: "u": show only un-installed ports
+
+       pkgs=$(cat "$2" | sort -u)
+       [ -z "$pkgs" ] && return 0
+
+       Msg_NoQuiet "$1"
+       Msg_NoQuiet -n "  "
+       declare -i x=2
+       declare -i count=0
+       for d in $pkgs; do
+               grep "^  $d " "$TMPDIR/installed" >/dev/null 2>&1; local r=$?
+               if [ "$3" = "u" ]; then
+                       [ $r -eq 0 ] && continue
+               else
+                       [ $r -eq 0 ] && d="$d[i]"
+               fi
+               x=$x+${#d}+1
+               if [ $x -gt $WIDTH ]; then
+                       Msg_NoQuiet; Msg_NoQuiet -n "  "
+                       x=${#d}+3
+               fi
+               Msg_NoQuiet -n "$d "
+               count=$count+1
+       done
+       Msg_NoQuiet
+       return $count
+}
+
+Count_Package_File() {
+       # Return number of packages listed in a "pt package-list file".
+       # $1: package-list file name
+       # $2: "u": show only un-installed ports
+
+       pkgs=$(cat "$1" | sort -u)
+       declare -i count=0
+       for d in $pkgs; do
+               grep "^  $d " "$TMPDIR/installed" >/dev/null 2>&1; local r=$?
+               if [ "$2" = "u" ]; then
+                       [ $r -eq 0 ] && continue
+               fi
+               count=$count+1
+       done
+       return $count
+}
+
+Deps_r() {
+       local phase=""
+       grep "^$1\$" "$TMP4" >/dev/null 2>&1
+       if [ $? -eq 0 ]; then
+               Debug_Msg "Dependencies for \"$1\" already checked. Skipping."
+               return
+       fi
+       Debug_Msg "Checking dependencies for \"$1\" ..."
+       echo "$1" >>"$TMP4"
+       port deps "$1" | while read x; do
+               if [ "$x" = "$1 has no dependencies" ]; then
+                       phase=""; continue;
+               fi
+               if [ "$x" = "$1 has build dependencies on:" ]; then
+                       phase="build"; continue
+               fi
+               if [ "$x" = "$1 has library dependencies on:" ]; then
+                       phase="lib"; continue
+               fi
+               if [ "$x" = "$1 has runtime dependencies on:" ]; then
+                       phase="runtime"; continue
+               fi
+
+               case "$phase" in
+                       "build")
+                               echo "$1:$x" >>"$TMP1"
+                               Deps_r "$x"
+                               ;;
+                       "lib")
+                               echo "$1:$x" >>"$TMP2"
+                               Deps_r "$x"
+                               ;;
+                       "runtime")
+                               echo "$1:$x" >>"$TMP3"
+                               Deps_r "$x"
+                               ;;
+                       *)
+                               Warn_Msg "Unknown phase, token \"$x\"!?"
+               esac
+       done
+}
+
+Deps_a() {
+       # 1: level
+       # 2: file
+       # 3: type
+       # 4: root-element
+
+       declare -i level=$1
+       local deps=""
+       local t=""
+       
+       [ -z "$4" ] && t=$(head -n 1 "$2" | cut -d':' -f1) || t="$4"
+
+       while [ -n "$t" ]; do
+               deps=$(grep "^$t:" "$2" 2>/dev/null | sort -u)
+               grep -v "^$t:" "$2" >"$TMP" 2>/dev/null
+               cat "$TMP" >"$2"
+
+               for d in $deps; do
+                       port=$(echo "$d" | cut -d':' -f1)
+                       req=$(echo "$d" | cut -d':' -f2)
+       
+                       declare -i x=0
+                       while [ $x -lt $level ]; do
+                               [ -n "$VERBOSE" -a -z "$QUIET" ] && echo -n '  '
+                               x=$x+1
+                       done
+       
+                       Verbose_Msg "Port \"$t\" depends on $req"
+                       echo "$req" >>"$TMPDIR/required"
+       
+                       Deps_a $level+1 "$2" "$3" "$req"
+               done
+
+               [ "$level" -le 1 ] && t=$(head -n 1 "$2" | cut -d':' -f1) || t=""
+       done
+}
+
+Deps() {
+       # Display dependancies of a port
+       # $1: port
+
+       Port_Exists "$1"; local r=$?
+       [ $r -ne 0 ] && return $r
+
+       touch "$TMP1" "$TMP2" "$TMP3" "$TMP4"
+
+       Msg "Analyzing port \"$1\" ..."
+       Deps_r "$1"
+
+       build_deps=$(cat "$TMP1")
+       lib_deps=$(cat "$TMP2")
+       runtime_deps=$(cat "$TMP3")
+
+       if [ -z "$build_deps" -a -z "$lib_deps" -a -z "$runtime_deps" ]; then
+               Msg "Port \"$1\" has no dependencies."
+               return 0
+       fi
+
+       if [ -n "$build_deps" ]; then
+               Verbose_Msg; Verbose_Msg "Build dependencies:"
+               Deps_a 1 "$TMP1" build
+       fi
+       if [ -n "$lib_deps" ]; then
+               Verbose_Msg; Verbose_Msg "Library dependencies:"
+               Deps_a 1 "$TMP2" lib
+       fi
+       if [ -n "$runtime_deps" ]; then
+               Verbose_Msg; Verbose_Msg "Runtime dependencies:"
+               Deps_a 1 "$TMP3" runtime
+       fi
+       Msg
+
+       deps=$(cat "$TMPDIR/required" | sort -u)
+       declare -i count=$(cat "$TMPDIR/required" | sort -u | wc -l )
+       not_inst=""
+
+       [ "$count" -eq 1 ] \
+               && Msg_NoQuiet "The following port is required by \"$1\":" \
+               || Msg_NoQuiet "The following $count ports are required by \"$1\":"
+       Msg_NoQuiet -n "  "
+       declare -i count=0
+       declare -i x=2
+       for d in $deps; do
+               grep "^  $d " "$TMPDIR/installed" >/dev/null 2>&1; local r=$?
+               if [ $r -eq 0 ]; then
+                        d="$d[i]"
+               else
+                       count=$count+1
+                       not_inst="$not_inst $d"
+               fi
+               x=$x+${#d}+1
+               if [ $x -gt $WIDTH ]; then
+                       Msg_NoQuiet; Msg_NoQuiet -n "  "
+                       declare -i x=${#d}+3
+               fi
+               Msg_NoQuiet -n "$d "
+       done
+       Msg_NoQuiet
+
+       if [ -n "$not_inst" ]; then
+               [ "$count" -eq 1 ] \
+                       && Msg_NoQuiet "The following port (probably) needs to be installed:" \
+                       || Msg_NoQuiet "The following $count ports (probably!) need to be installed:"
+               Msg_NoQuiet -n "  "
+               declare -i x=2
+               for d in $not_inst; do
+                       x=$x+${#d}+1
+                       if [ $x -gt $WIDTH ]; then
+                               Msg_NoQuiet; Msg_NoQuiet -n "  "
+                               declare -i x=${#d}+3
+                       fi
+                       Msg_NoQuiet -n "$d "
+                       echo "$d" >>"$TMPDIR/missing"
+               done
+               Msg_NoQuiet
+       else
+               Msg_NoQuiet "All required ports are already installed."
+       fi
+
+       Msg
+       return 0
+}
+
+Port_Install() {
+       # Install a given port, and its dependencies.
+       # $*: port, including version number, variant(s), ...
+
+       Msg_NoQuiet "Installing port \"$p\" (and dependencies) ..."
+
+       local args=""
+       [ -n "$CLEAN_WORKDIR" ] && args="$args -c"
+
+       PortCmd $args install $*
+       if [ $? -ne 0 ]; then
+               Error_Msg "Installation of \"$1\" failed!"
+               return 1
+       fi
+       return 0
+}
+
+Port_Upgrade() {
+       # Clean build directory of a port
+       # $1: port
+       # $2: old version
+       # $3: new version
+
+       Msg_NoQuiet "Upgrading port \"$1\" (and dependencies): $2 -> $3 ..."
+
+       local args=""
+       [ -n "$CLEAN_WORKDIR" ] && args="$args -c"
+       [ -n "$UPGRADE_REMOVE_INACTIVE" ] && args="$args -fu"
+
+       PortCmd $args upgrade -n $port
+       if [ $? -ne 0 ]; then
+               Error_Msg "Failed to upgrade port \"$1\"!"
+               return 1
+       fi
+       return 0
+}
+
+Port_Clean() {
+       # Clean build directory of a port
+       # $1: port
+
+       Msg_NoQuiet "Cleaning build directory of port \"$1\" ..."
+
+       PortCmd clean --all "$1"
+       if [ $? -ne 0 ]; then
+               Error_Msg "Failed to clean port \"$1\"!"
+               return 1
+       fi
+       return 0
+}
+
+Port_Remove() {
+       # Remove a given port
+       # $1: port
+
+       Msg_NoQuiet "Removing port \"$1\" ..."
+
+       PortCmd uninstall "$1"
+       if [ $? -ne 0 ]; then
+               Error_Msg "Failed to remove port \"$1\"!"
+               return 1
+       fi
+       return 0
+}
+
+Install() {
+       if [ $# -lt 1 ]; then
+               Error_Msg "No ports requested!?"
+               return 1
+       fi
+
+       deps=$(cat "$TMPDIR/required.all" | sort -u)
+       not_inst=""
+       
+       cat "$TMPDIR/missing.all" >"$TMPDIR/install.all"
+       for p in $*; do
+               echo "$p" >>"$TMPDIR/install.all"
+       done
+       
+       for p in $*; do
+               echo "$p" >>"$TMPDIR/requested.all"
+       done
+       
+       Verbose_Msg
+
+       if [ -z "$QUIET" ]; then
+               Count_Package_File "$TMPDIR/requested.all"; c=$?
+               [ $c -eq 1 ] && s=" has" || s="s have"
+               Dump_Package_File \
+                       "The following $c port$s been requested:" \
+                       "$TMPDIR/requested.all"
+       fi
+       Count_Package_File "$TMPDIR/required.all"; c_req=$?
+       [ $c_req -eq 1 ] && s=" is" || s="s are"
+       Dump_Package_File \
+               "The following $c_req port$s required to fulfil dependencies:" \
+               "$TMPDIR/required.all"
+       Count_Package_File "$TMPDIR/missing.all"; c_add=$?
+       [ $c_add -eq 1 ] && s=" (probably!) needs" || s="s (probably!) need"
+       Dump_Package_File \
+               "The following $c_add additional port$s to be installed:" \
+               "$TMPDIR/missing.all"
+       Count_Package_File "$TMPDIR/install.all" "u"; c_all=$?
+       if [ $c_all -lt 1 ]; then
+               Msg_NoQuiet "No new ports to install."; Msg
+               return 0
+       fi
+       [ $c_all -eq 1 ] && s="" || s="s"
+       Dump_Package_File \
+               "The following $c_all NEW port$s will be installed (if required):" \
+               "$TMPDIR/install.all" "u"
+       c_inst=$?
+
+       ports=$(tail -r "$TMPDIR/missing.all" | uniq )
+       ports="$ports $*"
+       if [ -n "$DEBUG" ]; then
+               Debug_Msg "Order of installation:"
+               Debug_Msg "  " $ports
+       fi
+
+       [ "$#" -eq 1 ] && s1=" has" || s1="s have"
+       [ "$c_inst" -eq 1 ] && s2="" || s2="s"
+       Msg_NoQuiet "$# port$s1 been requested, $c_inst port$s2 will be installed."
+       if [ $# -ne $c_inst ]; then
+               Prompt "Do you want to continue?"
+               if [ $? -ne 0 ]; then
+                       Msg "Aborting."; Msg
+                       return 1
+               fi
+       fi
+       Msg
+
+       declare -i errors=0
+       declare -i count=0
+
+       for p in $*; do
+               Port_Install "$p"
+               [ $? -eq 0 ] || errors=$errors+1
+
+               count=$count+1
+       done
+       Msg
+
+       [ $count -eq 1 ] && s=" has" || s="s have"
+       Msg "$count requested port$s been installed."
+       if [ $errors -gt 0 ]; then
+               [ $errors -gt 1 ] && s="s" || s=""
+               Error_Msg "There have been failures, see above!";
+               Msg
+               local r=1
+       else
+               local r=0
+       fi
+
+       Init
+       return $r
+}
+
+Init_Outdated() {
+       Msg "Searching for outdated ports ..."
+       echo -n "" >"$TMPDIR/outdated"
+       echo -n "" >"$TMPDIR/outdated.info"
+       port outdated | \
+        grep -v "No installed ports are outdated" | \
+        grep -v "The following installed ports are outdated" | \
+        awk "{ print \$1, \$2, \$3, \$4 }" | while read port v1 a v2; do
+               echo "$port" >>"$TMPDIR/outdated"
+               echo "$port $v1 $a $v2" >>"$TMPDIR/outdated.info"
+       done
+}
+
+List_Outdated() {
+       Init_Outdated
+       Count_Package_File "$TMPDIR/outdated"
+       if [ $? -lt 1 ]; then
+               Msg "No installed ports are outdated."
+               return 0
+       fi
+       Dump_Package_File \
+               "The following installed ports are outdated and will be UPGRADED:" \
+               "$TMPDIR/outdated"
+       c_out=$?
+
+       if [ -n "$VERBOSE" ]; then
+               echo "Upgrade details:"
+               cat "$TMPDIR/outdated.info" | while read port v1 a v2; do
+                       echo "  $port $v1 -> $v2"
+               done
+       fi
+       
+       [ $c_out -gt 100 ] && c_out=100
+       return $c_out;
+}
+
+Upgrade() {
+       List_Outdated && return 0
+
+       Prompt "Do you want to continue?"
+       if [ $? -ne 0 ]; then
+               Msg "Aborting."; Msg
+               return 1
+       fi
+       Msg
+
+       declare -i errors=0
+       cat "$TMPDIR/outdated.info" | while read port v1 a v2; do
+               Port_Upgrade "$port" "$v1" "$v2"
+               [ $? -eq 0 ] || errors=$errors+1
+       done
+       Msg
+
+       if [ $errors -gt 0 ]; then
+               [ $errors -gt 1 ] && s="s" || s=""
+               Warn_Msg "$errors error$s occured during upgrading!"
+               Msg
+               local r=1
+       else
+               local r=0
+       fi
+
+       Init_Outdated
+       Count_Package_File "$TMPDIR/outdated"; c=$?
+       if [ $c -gt 0 ]; then
+               if [ $c -eq 1 ]; then
+                       s1="is"; s2=""
+               else
+                       s1="are"; s2="s"
+               fi
+               Warn_Msg "There $s1 still $c outdated port$s2 installed!"
+       fi
+
+       Init
+       return $r
+}
+
+Update() {
+       Status "Actual ports base version" -q
+       Msg "Updating installed port software and database ..."
+       port -q selfupdate; local r=$?
+       if [ $r -eq 0 ]; then
+               Status "New ports base version"
+       else
+               Error_Msg "Failed to update port archive!"
+       fi
+       return $r
+}
+
+Clean() {
+       local r=0
+       declare -i errors=0
+       for p in $*; do
+               Port_Exists "$p"
+               if [ $? -eq 0 ]; then
+                       Port_Clean "$p"
+                       [ $? -ne 0 ] && errors=$errors+1
+               else
+                       errors=$errors+1
+               fi
+       done
+       if [ $errors -gt 0 ]; then
+               Msg_NoQuiet
+               [ $errors -ne 1 ] && s="s" || s=""
+               Error_Msg "$errors failure$s while cleaning ports!"
+               r=1
+       fi
+       return $r
+}
+
+Remove() {
+       local r=0
+       declare -i errors=0
+       for p in $*; do
+               Port_Installed "$p"
+               if [ $? -eq 0 ]; then
+                       Port_Remove "$p"
+                       [ $? -ne 0 ] && errors=$errors+1
+               else
+                       errors=$errors+1
+               fi
+       done
+       if [ $errors -gt 0 ]; then
+               [ $errors -ne 1 ] && s="s" || s=""
+               Error_Msg "$errors failure$s while removing ports!"
+               r=1
+       fi
+       return $r
+}
+
+Status() {
+       local r=0
+       Init; r=$?
+       q=$QUIET; [ "$2" != '-q' ] && QUIET=
+       [ "$1" = "" ] \
+               && Msg -n "Ports base version: " \
+               || Msg -n "$1: "
+       version=$( port --version </dev/null | grep "MacPorts" )
+       Msg "$version"
+       QUIET=$q
+       return $r
+}
+
+trap Clean_Exit_Signal SIGINT
+
+# read in defaults, if available
+[ -r "/etc/$NAME.conf" ] && . "/etc/$NAME.conf"
+
+while true; do
+       case "$1" in
+               "-v")
+                       VERBOSE=1; QUIET=
+                       shift
+                       ;;
+               "+v")
+                       VERBOSE=
+                       shift
+                       ;;
+               "-V")
+                       PORT_VERBOSE=1; VERBOSE=1
+                       shift
+                       ;;
+               "+V")
+                       PORT_VERBOSE=
+                       shift
+                       ;;
+               "-q")
+                       QUIET=1; VERBOSE=; DEBUG=
+                       shift
+                       ;;
+               "+q")
+                       QUIET=
+                       shift
+                       ;;
+               "-d")
+                       DEBUG=1; VERBOSE=1; QUIET=
+                       shift
+                       ;;
+               "+d")
+                       DEBUG=
+                       shift
+                       ;;
+               "--usage"|"--help"|"-*"|"+*")
+                       Usage
+                       ;;
+               "--version")
+                       Version
+                       Clean_Exit 0
+                       ;;
+               *)
+                       break;
+       esac
+done
+
+TMPDIR=`mktemp -d /tmp/${NAME}.XXXXXX` || exit 2
+Debug_Msg "Temporary directory is \"$TMPDIR\"."
+
+TMP="$TMPDIR/tmp"
+TMP1="$TMPDIR/tmp.1"
+TMP2="$TMPDIR/tmp.2"
+TMP3="$TMPDIR/tmp.3"
+TMP4="$TMPDIR/tmp.4"
+
+r=0
+case "$1" in
+       "clean")
+               shift
+               Check_Root_Perm
+               [ $# -lt 1 ] && Usage
+               Init
+               Clean $*
+               Clean_Exit $?
+               ;;
+       "deps")
+               shift
+               [ $# -lt 1 ] && Usage
+               Init
+               for p in $*; do
+                       Reset
+                       Deps "$p"; r=$?
+                       [ $r -ne 0 ] && Clean_Exit $r
+               done
+               Clean_Exit $r
+               ;;
+       "install")
+               shift
+               Check_Root_Perm
+               [ $# -lt 1 ] && Usage
+               Init
+               Verbose_Msg "Building port dependencies ..."
+               for p in $*; do
+                       Port_Exists "$p"
+                       [ $? -ne 0 ] && Clean_Exit 1
+                       Reset
+                       Deps "$p" >/dev/null; r=$?
+                       [ $r -ne 0 ] && Clean_Exit $r
+               done
+               Reset
+               Install $*
+               Clean_Exit $?
+               ;;
+       "list")
+               shift
+               [ $# -lt 1 ] && Usage
+               port list $*
+               Clean_Exit $?
+               ;;
+       "outdated"|"list-outdated")
+               List_Outdated
+               Clean_Exit $?
+               ;;
+       "update"|"selfupdate")
+               shift
+               Check_Root_Perm
+               [ $# -ne 0 ] && Usage
+               Update
+               Clean_Exit $?
+               ;;
+       "upgrade"|"dist-upgrade")
+               shift
+               Check_Root_Perm
+               [ $# -gt 0 ] && Usage
+               Init
+               Upgrade
+               Clean_Exit $?
+               ;;
+       "remove"|"uninstall")
+               shift
+               Check_Root_Perm
+               [ $# -lt 1 ] && Usage
+               Init
+               Remove $*
+               Clean_Exit $?
+               ;;
+       "search")
+               shift
+               [ $# -lt 1 ] && Usage
+               port search $*
+               Clean_Exit $?
+               ;;
+       "info")
+               shift
+               [ $# -lt 1 ] && Usage
+               port info $*
+               Clean_Exit $?
+               ;;
+       "status")
+               shift
+               [ $# -ne 0 ] && Usage
+               VERBOSE=1; Status
+               Clean_Exit $?
+               ;;
+       *)
+               Usage
+esac
+
+# -eof-
diff --git a/etc/pt.conf b/etc/pt.conf
new file mode 100644 (file)
index 0000000..ed1c80b
--- /dev/null
@@ -0,0 +1,37 @@
+#
+# pt -- the MacPorts port tool
+# Default configuration settings
+#
+# $Id$
+#
+# The following settings are boolean options. If a variable is set the
+# option is enabled, the value of the variable doesn't matter. To disable
+# an option, the variable must be empty/unset.
+#
+# Note: the value "0" is "set", so the option will be enabled!
+# Use "XYZ=1" to enable an options, and "XYZ=" to disaple it.
+#
+
+# Run in "quiet mode", very few output. [Default: empty (=off)]
+#QUIET=1
+
+# Run in "verbose mode", display more information. [Default: empty (=off)]
+#VERBOSE=1
+
+# Run the port(1) command in "verbose" mode, so more output is displayed
+# when MacPorts is working. [Default: empty (=off)]
+#PORT_VERBOSE=1
+
+# Enable "debug mode": a lot of (useful?) information is displayed.
+# Very useful when analyzing problems with pt(1). [Default: empty (=off)]
+#DEBUG=1
+
+# Remove ports which have been deaktivated during upgrades, as the old
+# versions of an installed port. [Default: 1 (=on)]
+#UPGRADE_REMOVE_INACTIVE=
+
+# Use "autoclean mode" of the port(1) command, e. g. execute the "clean"
+# target after installation of packages. [Default: 1 (=on)]
+#CLEAN_WORKDIR=
+
+# -eof-